<?php
function sendRequest($xml) {

	global $xmlAPIUrl;
	$header = "POST /XMLService.ASP HTTP/1.0\r\n";
	$header .= "Host: kunaki.com\r\n";
	$header .= "Content-Type: text/xml\r\n";
	$header .= "Content-Length: " . strlen($xml) . "\r\n";
	$header .= "\r\n";
	
	$fp = fsockopen($xmlAPIUrl, 80, $errno, $errstr);
	if(!$fp) {
		echo 'Fatal Error ' . $errno . ': ' . $errstr;
		exit();
	}
	else {
		fputs($fp, $header . $xml);
		$response = '';
		$head = true;
		while($str = fgets($fp, 1024)) {
			
			if(substr($str, 0, 10)=="<Response>") $head = false;
			if(!$head) $response .= $str;
		}
		return $response;
	}
}

function SoapToXml($data) {
	$parser =  xml_parser_create();
	xml_parse_into_struct($parser, $data, $vals, $index);
	xml_parser_free($parser);
	return array($vals, $index);
}

function XmlToArray($vals) { // converts raw array into structed array
	$ct = array();
	$vals = array_merge($ct, $vals);

	for($i = 0; $i < count($vals); $i++) {
		$deep = $vals[$i]['level'];
		$var = 'ind' . $deep;
		if($$var == '') $$var = 0;
		$array[$deep][$$var]['name'] = strtolower($vals[$i]['tag']);
		$array[$deep][$$var]['type'] = $vals[$i]['type'];
		$array[$deep][$$var]['value'] = $vals[$i]['value'];
		$array[$deep][$$var]['id'] = $i;
		$$var++;
	}

	$array = array_reverse($array, true);
	$cur = array();
	$prev = array();
	foreach ($array as $key => $value) {
		$st = '';
		$nd = '';
		$n = '';
		for($i = 0; $i < count($value); $i++) {
			if($value[$i]['type'] == 'open') {
				$st = $value[$i]['id'];
				$n = $value[$i]['name'];
			}
			if($value[$i]['type'] == 'close') {
				$nd = $value[$i]['id'];
				$o = 0;
				for($z = $st + 1; $z < $nd; $z++) {
					$cur[$st][$n][$o] = $prev[$z];
					$o++;
				}
				$st = '';
				$nd = '';
				$n = '';
			}
			if($value[$i]['type'] == 'complete') {
				$cur[$value[$i]['id']]['name'] = $value[$i]['name'];
				$cur[$value[$i]['id']]['value'] = $value[$i]['value'];
			}
		}
		$prev = $cur;
		$cur = array();
	}
	$result = AssocArray($prev);
	return $result;
}

function AssocArray($array) { // converts structed array into associated array
	if(!is_array($array)) return $array;
	foreach ($array as $key => $value) {
		if(trim($value) == '' && $key != 'value') unset($array[$key]);
		else {
			if(is_numeric($key)) {
				if(isset($value['name']) && array_key_exists('value', $value)) {
					unset($array[$key]);
					$array[strtolower($value['name'])] = $value['value'];
				}
				elseif(count($value) == 1) {
					foreach($value as $k => $v) { $val = AssocArray($v); }
					unset($array[$key]);
					if(!isset($array[$k])) $array[$k] = $val;
					elseif(!isset($array[$k][0])) {
						$tmp = $array[$k];
						$array[$k] = array();
						@array_push($array[$k], $tmp, $val);
					}
					else @array_push($array[$k], $val);
				}
				else {
					$array[$key] = AssocArray($value);
				}
			}
			else {
				$array[$key] = AssocArray($value);
			}
		}
	}
	return $array;
}

function sendUserEmail($orderID) {
	global $Email, $email_text, $Name, $payment_gross, $Address1, $Address2, $City, $State_Province, $PostalCode, $Country, $ShippingDescription, $ids, $items, $payer_email;
	
	$address = $Address1.($Address2!=''?' '.$Address2:'').', '.$City;
	$country = $State_Province . ', ' . $PostalCode . ', ' . $Country;
	
	for ($i = 0; $i < count($items); $i++) {
		for($j = 0; $j < count($ids); $j++) {
			if($ids[$j]==$items[$i]['pid']) {
				$titles .= ($titles!=''?', ':'').$items[$i]['title'];
			}
		}
	}

	$email_text = str_replace('{date}', date('m/d/Y H:i:s'), $email_text);
	$email_text = str_replace('{orderID}', $orderID, $email_text);
	$email_text = str_replace('{total}', number_format($payment_gross, 2, '.', ''), $email_text);
	$email_text = str_replace('{titles}', $titles, $email_text);
	$email_text = str_replace('{name}', $Name, $email_text);
	$email_text = str_replace('{address}', $address, $email_text);
	$email_text = str_replace('{country}', $country, $email_text);
	$email_text = str_replace('{option}', $ShippingDescription, $email_text);
	$email_text = str_replace('{email}', $Email, $email_text);
	$email_text = str_replace('{pp_email}', $payer_email, $email_text);
	
	echo $Email;
	
	$header = "Cc: editor@infoproductlab.com\r\nFrom: editor@infoproductlab.com\r\nReturn-path: editor@infoproductlab.com";
	mail($Email, 'Order', $email_text, $header);
}

function sendErrorNotice($error) {
	global $pp_vars;
	$message = "Hello,
There was an error in Shipping Order processing after actual PayPal payment has been made already. Here's error description: " . $error . "

Full list of PP variables (to track & refund the payment) below:
-----------------------------------------
";
	while(list($key, $val) = each($pp_vars)) {
		$message .= $key . ": " . $val . "\r\n";
	}
$message .= "
-----------------------------------------
";
	$header = "From: editor@infoproductlab.com";
	mail("editor@infoproductlab.com", "Order Error", $message, $header);
}
?>